<?php
namespace Incoviba\Repository\Venta;

use DateTimeImmutable;
use Incoviba\Common\Ideal;
use Incoviba\Common\Define;
use Incoviba\Common\Implement;
use Incoviba\Model;
use Incoviba\Service;

class Escritura extends Ideal\Repository
{
    public function __construct(Define\Connection $connection, protected Service\Venta\Pago $pagoService)
    {
        parent::__construct($connection);
        $this->setTable('escritura');
    }

    public function create(?array $data = null): Define\Model
    {
        $map = (new Implement\Repository\MapperParser())
            ->register('pago', (new Implement\Repository\Mapper())
                ->setFunction(function($data) {
                    return $this->pagoService->getById($data['pago']);
                }))
            ->register('fecha', new Implement\Repository\Mapper\DateTime('fecha'));
        return $this->parseData(new Model\Venta\Escritura(), $data, $map);
    }
    public function save(Define\Model $model): Define\Model
    {
        $model->id = $this->saveNew(
            ['valor', 'fecha', 'uf', 'abonado', 'fecha_abono', 'pago'],
            [$model->pago->valor, $model->fecha->format('Y-m-d'), $model->pago->uf, null, null, $model->pago->id]
        );
        return $model;
    }
    public function edit(Define\Model $model, array $new_data): Define\Model
    {
        return $this->update($model, ['valor', 'fecha', 'uf', 'abonado', 'fecha_abono', 'pago'], $new_data);
    }
}
